#include "camids.h"
#include "mylogger.h"
#include "util.h"



CameraID::CameraID(Pylon::DeviceInfoList &deviceList, QWidget *parent) :
    deviceList(deviceList), QDialog(parent) {
    device_combo = new QComboBox(this);
    for (auto d : deviceList) {
        device_combo->addItem(QString(d.GetFullName()) + " - " + QString(d.GetUserDefinedName()));
    }
    connect(device_combo, SIGNAL(currentIndexChanged(int)), SLOT(primaryDeviceChanged(int)));

    QWidget *header = new QWidget(this);
    QGridLayout *grid = new QGridLayout(header);
    grid->addWidget(new QLabel("Camera device:", this), 1, 0);
    grid->addWidget(device_combo, 1, 1);

    edit = new QLineEdit(this);
    grid->addWidget(new QLabel("Camera Id", this), 2, 0);
    grid->addWidget(edit, 2, 1);
    header->setLayout(grid);

    QVBoxLayout *vbox = new QVBoxLayout(this);
    vbox->addWidget(header);

    buttonbox = new QDialogButtonBox(QDialogButtonBox::Ok
                                   | QDialogButtonBox::Cancel);
    connect(buttonbox, &QDialogButtonBox::accepted, this, &QDialog::accept);
    connect(buttonbox, &QDialogButtonBox::rejected, this, &QDialog::reject);
    vbox->addWidget(buttonbox);
    std::cerr <<"ping\n";
}

void CameraID::setID() {
    std::cerr << "Set ID!" << std::endl;
}

QString CameraID::newID() {
    std::cerr <<"ping\n";
    return edit->text();
}

int CameraID::cameraIndex() {
    std::cerr <<"ping\n";
    return device_combo->currentIndex();
}